Index: /LMDZ4/trunk/libf/dyn3dpar/logic.h
===================================================================
--- /LMDZ4/trunk/libf/dyn3dpar/logic.h	(revision 999)
+++ /LMDZ4/trunk/libf/dyn3dpar/logic.h	(revision 1000)
@@ -2,18 +2,18 @@
 ! $Header$
 !
-c
-c
-c-----------------------------------------------------------------------
-c INCLUDE 'logic.h'
+!
+!
+!-----------------------------------------------------------------------
+! INCLUDE 'logic.h'
 
-      COMMON/logic/ purmats,iflag_phys,forward,leapf,apphys,
-     .  statcl,conser,apdiss,apdelq,saison,ecripar,fxyhypb,ysinus
-     .  ,read_start,ok_guide
+      COMMON/logic/ purmats,iflag_phys,forward,leapf,apphys,            &
+     &  statcl,conser,apdiss,apdelq,saison,ecripar,fxyhypb,ysinus       &
+     &  ,read_start,ok_guide,ok_strato
 
-      LOGICAL purmats,forward,leapf,apphys,statcl,conser,
-     . apdiss,apdelq,saison,ecripar,fxyhypb,ysinus
-     .  ,read_start,ok_guide
+      LOGICAL purmats,forward,leapf,apphys,statcl,conser,               &
+     & apdiss,apdelq,saison,ecripar,fxyhypb,ysinus                      &
+     &  ,read_start,ok_guide,ok_strato
 
       INTEGER iflag_phys
-c$OMP THREADPRIVATE(/logic/)
-c-----------------------------------------------------------------------
+!$OMP THREADPRIVATE(/logic/)
+!-----------------------------------------------------------------------
Index: /LMDZ4/trunk/libf/dyn3dpar/mod_const_para.F90
===================================================================
--- /LMDZ4/trunk/libf/dyn3dpar/mod_const_para.F90	(revision 999)
+++ /LMDZ4/trunk/libf/dyn3dpar/mod_const_para.F90	(revision 1000)
@@ -11,5 +11,7 @@
 
     IMPLICIT NONE
+#ifdef CPP_MPI
     INCLUDE 'mpif.h'
+#endif
     INTEGER             :: ierr
     INTEGER             :: comp_id
@@ -30,19 +32,39 @@
        CALL prism_get_localcomm_proto(COMM_LMDZ,ierr)
 !$OMP END MASTER
+#ifdef CPP_MPI
+      COMM_LMDZ=MPI_COMM_WORLD
+      MPI_REAL_LMDZ=MPI_REAL8
+#endif
 #endif
     ELSE
+      CALL init_mpi
+    ENDIF
+
+  END SUBROUTINE Init_const_mpi
+  
+  SUBROUTINE Init_mpi
+  IMPLICIT NONE
+#ifdef CPP_MPI
+     INCLUDE 'mpif.h'
+#endif
+    INTEGER             :: ierr
+    INTEGER             :: thread_required
+    INTEGER             :: thread_provided
+
+#ifdef CPP_MPI
 !$OMP MASTER
-       thread_required=MPI_THREAD_SERIALIZED
-       CALL MPI_INIT_THREAD(thread_required,thread_provided,ierr)
-       IF (thread_provided < thread_required) THEN
-         CALL abort_gcm('The multithreaded level of MPI librairy do not provide the requiered level', &
-                        'mod_const_mpi::Init_const_mpi',1)
-       ENDIF
-       COMM_LMDZ=MPI_COMM_WORLD
+      thread_required=MPI_THREAD_SERIALIZED
+
+      CALL MPI_INIT_THREAD(thread_required,thread_provided,ierr)
+      IF (thread_provided < thread_required) THEN
+        PRINT *,'Warning : The multithreaded level of MPI librairy do not provide the requiered level',  &
+                ' in mod_const_mpi::Init_const_mpi'
+      ENDIF
+      COMM_LMDZ=MPI_COMM_WORLD
+      MPI_REAL_LMDZ=MPI_REAL8
 !$OMP END MASTER
-    END IF
+#endif
 
-    MPI_REAL_LMDZ=MPI_REAL8
-  END SUBROUTINE Init_const_mpi
-
+   END SUBROUTINE Init_mpi
+    
 END MODULE mod_const_mpi
Index: /LMDZ4/trunk/libf/dyn3dpar/mod_hallo.F90
===================================================================
--- /LMDZ4/trunk/libf/dyn3dpar/mod_hallo.F90	(revision 999)
+++ /LMDZ4/trunk/libf/dyn3dpar/mod_hallo.F90	(revision 1000)
@@ -50,5 +50,5 @@
     MaxBufferSize_Used=0
 
-    IF (use_mpi_alloc) THEN
+    IF (use_mpi_alloc .AND. using_mpi) THEN
       CALL create_global_mpi_buffer
     ELSE 
@@ -67,8 +67,14 @@
   SUBROUTINE create_global_mpi_buffer
   IMPLICIT NONE
-  INCLUDE 'mpif.h'  
+#ifdef CPP_MPI
+  INCLUDE 'mpif.h'
+#endif  
     POINTER (Pbuffer,MPI_Buffer(MaxBufferSize))
     REAL :: MPI_Buffer
+#ifdef CPP_MPI
     INTEGER(KIND=MPI_ADDRESS_KIND) :: BS 
+#else
+    INTEGER(KIND=8) :: BS
+#endif
     INTEGER :: i,ierr
 
@@ -76,5 +82,7 @@
       Bs=8*MaxBufferSize
 !$OMP CRITICAL (MPI)
+#ifdef CPP_MPI
       CALL MPI_ALLOC_MEM(BS,MPI_INFO_NULL,Pbuffer,ierr)
+#endif
 !$OMP END CRITICAL (MPI)
       DO i=1,MaxBufferSize
@@ -164,5 +172,4 @@
 #include "dimensions.h"
 #include "paramet.h"    
-    include 'mpif.h'
     
       INTEGER :: ij,ll,offset,size,target
@@ -186,5 +193,4 @@
 #include "dimensions.h"
 #include "paramet.h"    
-    include 'mpif.h'
     
       INTEGER :: ij,ll,offset,size,target
@@ -211,5 +217,4 @@
 #include "dimensions.h"
 #include "paramet.h"    
-    include 'mpif.h'
     
     INTEGER :: ij,ll
@@ -260,5 +265,4 @@
 #include "dimensions.h"
 #include "paramet.h"    
-    include 'mpif.h'
     
     INTEGER :: ij,ll,Up,Down
@@ -313,6 +317,7 @@
 #include "dimensions.h"
 #include "paramet.h"    
+#ifdef CPP_MPI
     include 'mpif.h'
-    
+#endif    
       INTEGER :: ij,ll
       REAL, dimension(ij,ll) :: Field
@@ -379,5 +384,7 @@
 #include "dimensions.h"
 #include "paramet.h"
+#ifdef CPP_MPI
       include 'mpif.h'
+#endif
 
       type(request),target :: a_request
@@ -428,6 +435,13 @@
     
 !$OMP CRITICAL (MPI)
-         call MPI_ISSEND(Buffer(req%Pos),SizeBuffer,MPI_REAL8,rank,a_request%tag+1000*omp_rank,     &
+         
+#ifdef CPP_MPI
+         call MPI_ISSEND(Buffer(req%Pos),SizeBuffer,MPI_REAL_LMDZ,rank,a_request%tag+1000*omp_rank,     &
                          COMM_LMDZ,Req%MSG_Request,ierr)
+#endif
+         IF (.NOT.using_mpi) THEN
+           PRINT *,'Erreur, echange MPI en mode sequentiel !!!'
+           STOP
+         ENDIF
 !         PRINT *,"-------------------------------------------------------------------"
 !         PRINT *,"Process de rang",mpi_rank,"Task : ",omp_rank,"--->"
@@ -460,6 +474,14 @@
              call allocate_buffer(SizeBuffer,Req%Index,Req%Pos)
 !$OMP CRITICAL (MPI)
-             call MPI_IRECV(Buffer(Req%Pos),SizeBuffer,MPI_REAL8,rank,a_request%tag+1000*omp_rank,     &
+
+#ifdef CPP_MPI
+             call MPI_IRECV(Buffer(Req%Pos),SizeBuffer,MPI_REAL_LMDZ,rank,a_request%tag+1000*omp_rank,     &
                            COMM_LMDZ,Req%MSG_Request,ierr)
+#endif             
+             IF (.NOT.using_mpi) THEN
+               PRINT *,'Erreur, echange MPI en mode sequentiel !!!'
+               STOP
+             ENDIF
+
 !         PRINT *,"-------------------------------------------------------------------"
 !         PRINT *,"Process de rang",mpi_rank,"Task : ",omp_rank,"--->"
@@ -480,5 +502,7 @@
 #include "dimensions.h"
 #include "paramet.h"
+#ifdef CPP_MPI
       include 'mpif.h'   
+#endif
       
       type(request),target :: a_request
@@ -486,5 +510,9 @@
       type(Hallo),pointer :: PtrHallo
       integer, dimension(2*mpi_size) :: TabRequest
+#ifdef CPP_MPI
       integer, dimension(MPI_STATUS_SIZE,2*mpi_size) :: TabStatus
+#else
+      integer, dimension(1,2*mpi_size) :: TabStatus
+#endif
       integer :: NbRequest
       integer :: i,rank,pos,ij,l,ierr
@@ -515,5 +543,7 @@
 !        PRINT *,"Process de rang",mpi_rank,"Task : ",omp_rank,"--->",NbRequest,"en attente"
 !        PRINT *,"No des requetes :",TabRequest(1:NbRequest)
+#ifdef CPP_MPI
         call MPI_WAITALL(NbRequest,TabRequest,TabStatus,ierr)
+#endif
 !        PRINT *,"Process de rang",mpi_rank,"Task : ",omp_rank,"--->",NbRequest,"complete"
 !        PRINT *,"-------------------------------------------------------------------"
@@ -567,11 +597,16 @@
 #include "dimensions.h"
 #include "paramet.h"
+#ifdef CPP_MPI
       include 'mpif.h'   
-      
+#endif      
       type(request),target :: a_request
       type(request_SR),pointer :: Req
       type(Hallo),pointer :: PtrHallo
       integer, dimension(mpi_size) :: TabRequest
+#ifdef CPP_MPI
       integer, dimension(MPI_STATUS_SIZE,mpi_size) :: TabStatus
+#else
+      integer, dimension(1,mpi_size) :: TabStatus
+#endif
       integer :: NbRequest
       integer :: i,rank,pos,ij,l,ierr
@@ -594,5 +629,7 @@
 !        PRINT *,"Process de rang",mpi_rank,"Task : ",omp_rank,"--->",NbRequest,"en attente"
 !        PRINT *,"No des requetes :",TabRequest(1:NbRequest)
+#ifdef CPP_MPI
         call MPI_WAITALL(NbRequest,TabRequest,TabStatus,ierr)
+#endif
 !        PRINT *,"Process de rang",mpi_rank,"Task : ",omp_rank,"--->",NbRequest,"complete"
 !        PRINT *,"-------------------------------------------------------------------"
@@ -617,5 +654,7 @@
 #include "dimensions.h"
 #include "paramet.h"
+#ifdef CPP_MPI
       include 'mpif.h'   
+#endif
       
       type(request),target :: a_request
@@ -623,5 +662,9 @@
       type(Hallo),pointer :: PtrHallo
       integer, dimension(mpi_size) :: TabRequest
+#ifdef CPP_MPI
       integer, dimension(MPI_STATUS_SIZE,mpi_size) :: TabStatus
+#else
+      integer, dimension(1,mpi_size) :: TabStatus
+#endif
       integer :: NbRequest
       integer :: i,rank,pos,ij,l,ierr
@@ -645,5 +688,7 @@
 !        PRINT *,"Process de rang",mpi_rank,"Task : ",omp_rank,"--->",NbRequest,"en attente"
 !        PRINT *,"No des requetes :",TabRequest(1:NbRequest)
+#ifdef CPP_MPI
         call MPI_WAITALL(NbRequest,TabRequest,TabStatus,ierr)
+#endif
 !        PRINT *,"Process de rang",mpi_rank,"Task : ",omp_rank,"--->",NbRequest,"complete"
 !        PRINT *,"-------------------------------------------------------------------"
@@ -691,5 +736,4 @@
 #include "dimensions.h"
 #include "paramet.h"    
-    include 'mpif.h'
     
     INTEGER :: ij,ll,l
@@ -731,5 +775,4 @@
 #include "dimensions.h"
 #include "paramet.h"    
-    include 'mpif.h'
     
     INTEGER :: ij,ll,Up,Down
Index: /LMDZ4/trunk/libf/dyn3dpar/parallel.F90
===================================================================
--- /LMDZ4/trunk/libf/dyn3dpar/parallel.F90	(revision 999)
+++ /LMDZ4/trunk/libf/dyn3dpar/parallel.F90	(revision 1000)
@@ -1,5 +1,8 @@
   module parallel
   USE mod_const_mpi
-   
+    
+    LOGICAL,SAVE :: using_mpi
+    LOGICAL,SAVE :: using_omp
+    
     integer, save :: mpi_size
     integer, save :: mpi_rank
@@ -25,4 +28,9 @@
     USE vampir
     implicit none
+#ifdef CPP_MPI
+      include 'mpif.h'
+#endif
+#include "dimensions.h"
+#include "paramet.h"
     
       integer :: ierr
@@ -31,5 +39,6 @@
       integer, dimension(3) :: blocklen,type
       integer :: comp_id
-#ifdef _OPENMP    
+
+#ifdef CPP_OMP    
       INTEGER :: OMP_GET_NUM_THREADS
       EXTERNAL OMP_GET_NUM_THREADS
@@ -37,11 +46,22 @@
       EXTERNAL OMP_GET_THREAD_NUM
 #endif  
-      include 'mpif.h'
-#include "dimensions.h"
-#include "paramet.h"
-
+
+#ifdef CPP_MPI
+       using_mpi=.TRUE.
+#else
+       using_mpi=.FALSE.
+#endif
+      
       call InitVampir
-      call MPI_COMM_SIZE(COMM_LMDZ,mpi_size,ierr)
-      call MPI_COMM_RANK(COMM_LMDZ,mpi_rank,ierr)
+      
+      IF (using_mpi) THEN
+#ifdef CPP_MPI
+        call MPI_COMM_SIZE(COMM_LMDZ,mpi_size,ierr)
+        call MPI_COMM_RANK(COMM_LMDZ,mpi_rank,ierr)
+#endif
+      ELSE
+        mpi_size=1
+        mpi_rank=0
+      ENDIF
   
       
@@ -57,8 +77,9 @@
           
          print *,"Arret : le nombre de bande de lattitude par process est trop faible (<2)."
-          print *," ---> diminuez le nombre de CPU ou augmentez la taille en lattitude"
+         print *," ---> diminuez le nombre de CPU ou augmentez la taille en lattitude"
           
-          call MPI_ABORT(COMM_LMDZ,-1, ierr)
-          
+#ifdef CPP_MPI
+          IF (using_mpi) call MPI_ABORT(COMM_LMDZ,-1, ierr)
+#endif          
         endif
         
@@ -106,5 +127,5 @@
 !$OMP PARALLEL
 
-#ifdef _OPENMP
+#ifdef CPP_OMP
 !$OMP MASTER
         omp_size=OMP_GET_NUM_THREADS()
@@ -162,8 +183,10 @@
       include "dimensions.h"
       include "paramet.h"
+#ifdef CPP_MPI
+      include 'mpif.h'
+#endif      
+
       integer :: ierr
       integer :: i
-      include 'mpif.h'
-      
       deallocate(jj_begin_para)
       deallocate(jj_end_para)
@@ -178,5 +201,7 @@
 #endif 
       else
-         call MPI_FINALIZE(ierr)
+#ifdef CPP_MPI
+         IF (using_mpi) call MPI_FINALIZE(ierr)
+#endif
       end if
       
@@ -229,4 +254,21 @@
       
     end subroutine UnPack_data
+
+    
+    SUBROUTINE barrier
+    IMPLICIT NONE
+#ifdef CPP_MPI
+    INCLUDE 'mpif.h'
+#endif
+    INTEGER :: ierr
+    
+!$OMP CRITICAL (MPI)      
+#ifdef CPP_MPI
+      IF (using_mpi) CALL MPI_Barrier(COMM_LMDZ,ierr)
+#endif
+!$OMP END CRITICAL (MPI)
+    
+    END SUBROUTINE barrier
+       
       
     subroutine exchange_hallo(Field,ij,ll,up,down)
@@ -235,6 +277,7 @@
 #include "dimensions.h"
 #include "paramet.h"    
+#ifdef CPP_MPI
     include 'mpif.h'
-    
+#endif    
       INTEGER :: ij,ll
       REAL, dimension(ij,ll) :: Field
@@ -245,5 +288,9 @@
       LOGICAL :: RecvUp,RecvDown
       INTEGER, DIMENSION(4) :: Request
+#ifdef CPP_MPI
       INTEGER, DIMENSION(MPI_STATUS_SIZE,4) :: Status
+#else
+      INTEGER, DIMENSION(1,4) :: Status
+#endif
       INTEGER :: NbRequest
       REAL, dimension(:),allocatable :: Buffer_Send_up,Buffer_Send_down
@@ -251,96 +298,106 @@
       INTEGER :: Buffer_size      
 
-!$OMP CRITICAL (MPI)      
-      call MPI_Barrier(COMM_LMDZ,ierr)
-!$OMP END CRITICAL (MPI)
-      call VTb(VThallo)
-      
-      SendUp=.TRUE.
-      SendDown=.TRUE.
-      RecvUp=.TRUE.
-      RecvDown=.TRUE.
-        
-      IF (pole_nord) THEN
-        SendUp=.FALSE.
-        RecvUp=.FALSE.
-      ENDIF
-  
-      IF (pole_sud) THEN
-        SendDown=.FALSE.
-        RecvDown=.FALSE.
-      ENDIF
-      
-      if (up.eq.0) then
-        SendDown=.FALSE.
-        RecvUp=.FALSE.
-      endif
-      
-      if (down.eq.0) then
-        SendUp=.FALSE.
-        RecvDown=.FALSE.
-      endif
-      
-      NbRequest=0
-  
-      IF (SendUp) THEN
-        NbRequest=NbRequest+1
-        buffer_size=down*iip1*ll
-        allocate(Buffer_Send_up(Buffer_size))
-        call PACK_Data(Field(ij_begin,1),ij,ll,down,Buffer_Send_up)
-!$OMP CRITICAL (MPI)
-        call MPI_ISSEND(Buffer_send_up,Buffer_Size,MPI_REAL8,MPI_Rank-1,1,     &
-                        COMM_LMDZ,Request(NbRequest),ierr)
-!$OMP END CRITICAL (MPI)
-      ENDIF
-  
-      IF (SendDown) THEN
-        NbRequest=NbRequest+1
-        
-        buffer_size=up*iip1*ll
-        allocate(Buffer_Send_down(Buffer_size))
-        call PACK_Data(Field(ij_end+1-up*iip1,1),ij,ll,up,Buffer_send_down)
-        
-!$OMP CRITICAL (MPI)
-        call MPI_ISSEND(Buffer_send_down,Buffer_Size,MPI_REAL8,MPI_Rank+1,1,     &
-                        COMM_LMDZ,Request(NbRequest),ierr)
-!$OMP END CRITICAL (MPI)
-      ENDIF
-    
-  
-      IF (RecvUp) THEN
-        NbRequest=NbRequest+1
-        buffer_size=up*iip1*ll
-        allocate(Buffer_recv_up(Buffer_size))
+      IF (using_mpi) THEN
+
+        CALL barrier
+      
+        call VTb(VThallo)
+      
+        SendUp=.TRUE.
+        SendDown=.TRUE.
+        RecvUp=.TRUE.
+        RecvDown=.TRUE.
+          
+        IF (pole_nord) THEN
+          SendUp=.FALSE.
+          RecvUp=.FALSE.
+        ENDIF
+    
+        IF (pole_sud) THEN
+          SendDown=.FALSE.
+          RecvDown=.FALSE.
+        ENDIF
+        
+        if (up.eq.0) then
+          SendDown=.FALSE.
+          RecvUp=.FALSE.
+        endif
+      
+        if (down.eq.0) then
+          SendUp=.FALSE.
+          RecvDown=.FALSE.
+        endif
+      
+        NbRequest=0
+  
+        IF (SendUp) THEN
+          NbRequest=NbRequest+1
+          buffer_size=down*iip1*ll
+          allocate(Buffer_Send_up(Buffer_size))
+          call PACK_Data(Field(ij_begin,1),ij,ll,down,Buffer_Send_up)
+!$OMP CRITICAL (MPI)
+#ifdef CPP_MPI
+          call MPI_ISSEND(Buffer_send_up,Buffer_Size,MPI_REAL8,MPI_Rank-1,1,     &
+                          COMM_LMDZ,Request(NbRequest),ierr)
+#endif
+!$OMP END CRITICAL (MPI)
+        ENDIF
+  
+        IF (SendDown) THEN
+          NbRequest=NbRequest+1
+           
+          buffer_size=up*iip1*ll
+          allocate(Buffer_Send_down(Buffer_size))
+          call PACK_Data(Field(ij_end+1-up*iip1,1),ij,ll,up,Buffer_send_down)
+        
+!$OMP CRITICAL (MPI)
+#ifdef CPP_MPI
+          call MPI_ISSEND(Buffer_send_down,Buffer_Size,MPI_REAL8,MPI_Rank+1,1,     &
+                          COMM_LMDZ,Request(NbRequest),ierr)
+#endif
+!$OMP END CRITICAL (MPI)
+        ENDIF
+    
+  
+        IF (RecvUp) THEN
+          NbRequest=NbRequest+1
+          buffer_size=up*iip1*ll
+          allocate(Buffer_recv_up(Buffer_size))
               
 !$OMP CRITICAL (MPI)
-        call MPI_IRECV(Buffer_recv_up,Buffer_size,MPI_REAL8,MPI_Rank-1,1,  &
-                        COMM_LMDZ,Request(NbRequest),ierr)
+#ifdef CPP_MPI
+          call MPI_IRECV(Buffer_recv_up,Buffer_size,MPI_REAL8,MPI_Rank-1,1,  &
+                          COMM_LMDZ,Request(NbRequest),ierr)
+#endif
 !$OMP END CRITICAL (MPI)
      
        
-      ENDIF
-  
-      IF (RecvDown) THEN
-        NbRequest=NbRequest+1
-        buffer_size=down*iip1*ll
-        allocate(Buffer_recv_down(Buffer_size))
-        
-!$OMP CRITICAL (MPI)
-        call MPI_IRECV(Buffer_recv_down,Buffer_size,MPI_REAL8,MPI_Rank+1,1,     &
-                        COMM_LMDZ,Request(NbRequest),ierr)
-!$OMP END CRITICAL (MPI)
-      
-        
-      ENDIF
-  
-      if (NbRequest > 0) call MPI_WAITALL(NbRequest,Request,Status,ierr)
-      IF (RecvUp)  call Unpack_Data(Field(ij_begin-up*iip1,1),ij,ll,up,Buffer_Recv_up)
-      IF (RecvDown) call Unpack_Data(Field(ij_end+1,1),ij,ll,down,Buffer_Recv_down)  
-
-      call VTe(VThallo)
-!$OMP CRITICAL (MPI)
-      call MPI_Barrier(COMM_LMDZ,ierr)
-!$OMP END CRITICAL (MPI)
-
+        ENDIF
+  
+        IF (RecvDown) THEN
+          NbRequest=NbRequest+1
+          buffer_size=down*iip1*ll
+          allocate(Buffer_recv_down(Buffer_size))
+        
+!$OMP CRITICAL (MPI)
+#ifdef CPP_MPI
+          call MPI_IRECV(Buffer_recv_down,Buffer_size,MPI_REAL8,MPI_Rank+1,1,     &
+                          COMM_LMDZ,Request(NbRequest),ierr)
+#endif
+!$OMP END CRITICAL (MPI)
+        
+        ENDIF
+  
+#ifdef CPP_MPI
+        if (NbRequest > 0) call MPI_WAITALL(NbRequest,Request,Status,ierr)
+#endif
+        IF (RecvUp)  call Unpack_Data(Field(ij_begin-up*iip1,1),ij,ll,up,Buffer_Recv_up)
+        IF (RecvDown) call Unpack_Data(Field(ij_end+1,1),ij,ll,down,Buffer_Recv_down)  
+
+        call VTe(VThallo)
+        call barrier
+      
+      ENDIF  ! using_mpi
+      
       RETURN
       
@@ -352,6 +409,7 @@
 #include "dimensions.h"
 #include "paramet.h"    
+#ifdef CPP_MPI
     include 'mpif.h'
-    
+#endif    
       INTEGER :: ij,ll,rank
       REAL, dimension(ij,ll) :: Field
@@ -362,60 +420,64 @@
       INTEGER ::i
       
-      if (ij==ip1jmp1) then 
-         allocate(Buffer_send(iip1*ll*(jj_end-jj_begin+1)))
-         call Pack_Data(Field(ij_begin,1),ij,ll,jj_end-jj_begin+1,Buffer_send)
-      else if (ij==ip1jm) then
-         allocate(Buffer_send(iip1*ll*(min(jj_end,jjm)-jj_begin+1)))
-         call Pack_Data(Field(ij_begin,1),ij,ll,min(jj_end,jjm)-jj_begin+1,Buffer_send)
-      else
-         print *,ij
-	 stop 'erreur dans Gather_Field'
-      endif
-      
-      if (MPI_Rank==rank) then
-        allocate(Buffer_Recv(ij*ll))
+      IF (using_mpi) THEN
+
+        if (ij==ip1jmp1) then 
+           allocate(Buffer_send(iip1*ll*(jj_end-jj_begin+1)))
+           call Pack_Data(Field(ij_begin,1),ij,ll,jj_end-jj_begin+1,Buffer_send)
+        else if (ij==ip1jm) then
+           allocate(Buffer_send(iip1*ll*(min(jj_end,jjm)-jj_begin+1)))
+           call Pack_Data(Field(ij_begin,1),ij,ll,min(jj_end,jjm)-jj_begin+1,Buffer_send)
+        else
+           print *,ij  
+        stop 'erreur dans Gather_Field'
+        endif
+        
+        if (MPI_Rank==rank) then
+          allocate(Buffer_Recv(ij*ll))
 
 !CDIR NOVECTOR
-        do i=0,MPI_Size-1
-           
+          do i=0,MPI_Size-1
+             
+            if (ij==ip1jmp1) then 
+              Recv_count(i)=(jj_end_para(i)-jj_begin_para(i)+1)*ll*iip1
+            else if (ij==ip1jm) then
+              Recv_count(i)=(min(jj_end_para(i),jjm)-jj_begin_para(i)+1)*ll*iip1
+            else
+              stop 'erreur dans Gather_Field'
+            endif
+                   
+            if (i==0) then 
+              displ(i)=0 
+            else
+              displ(i)=displ(i-1)+Recv_count(i-1)
+            endif
+            
+          enddo
+          
+        endif
+  
+!$OMP CRITICAL (MPI)
+#ifdef CPP_MPI
+        call MPI_GATHERV(Buffer_send,(min(ij_end,ij)-ij_begin+1)*ll,MPI_REAL8,   &
+                          Buffer_Recv,Recv_count,displ,MPI_REAL8,rank,COMM_LMDZ,ierr)
+#endif
+!$OMP END CRITICAL (MPI)
+      
+        if (MPI_Rank==rank) then                  
+      
           if (ij==ip1jmp1) then 
-            Recv_count(i)=(jj_end_para(i)-jj_begin_para(i)+1)*ll*iip1
+            do i=0,MPI_Size-1
+              call Unpack_Data(Field((jj_begin_para(i)-1)*iip1+1,1),ij,ll,                 &
+                               jj_end_para(i)-jj_begin_para(i)+1,Buffer_Recv(displ(i)+1))
+            enddo
           else if (ij==ip1jm) then
-            Recv_count(i)=(min(jj_end_para(i),jjm)-jj_begin_para(i)+1)*ll*iip1
-          else
-            stop 'erreur dans Gather_Field'
+            do i=0,MPI_Size-1
+               call Unpack_Data(Field((jj_begin_para(i)-1)*iip1+1,1),ij,ll,                       &
+                               min(jj_end_para(i),jjm)-jj_begin_para(i)+1,Buffer_Recv(displ(i)+1))
+            enddo
           endif
-                 
-          if (i==0) then 
-            displ(i)=0 
-          else
-            displ(i)=displ(i-1)+Recv_count(i-1)
-          endif
-          
-        enddo
-        
-      endif
-  
-!$OMP CRITICAL (MPI)
-      call MPI_GATHERV(Buffer_send,(min(ij_end,ij)-ij_begin+1)*ll,MPI_REAL8,   &
-                        Buffer_Recv,Recv_count,displ,MPI_REAL8,rank,COMM_LMDZ,ierr)
-!$OMP END CRITICAL (MPI)
-      
-      if (MPI_Rank==rank) then                  
-      
-        if (ij==ip1jmp1) then 
-          do i=0,MPI_Size-1
-            call Unpack_Data(Field((jj_begin_para(i)-1)*iip1+1,1),ij,ll,                 &
-                             jj_end_para(i)-jj_begin_para(i)+1,Buffer_Recv(displ(i)+1))
-          enddo
-        else if (ij==ip1jm) then
-          do i=0,MPI_Size-1
-             call Unpack_Data(Field((jj_begin_para(i)-1)*iip1+1,1),ij,ll,                       &
-                             min(jj_end_para(i),jjm)-jj_begin_para(i)+1,Buffer_Recv(displ(i)+1))
-          enddo
-        endif
-      
-      endif
-     
+        endif 
+      ENDIF ! using_mpi
+      
     end subroutine Gather_Field
 
@@ -425,14 +487,19 @@
 #include "dimensions.h"
 #include "paramet.h"    
+#ifdef CPP_MPI
     include 'mpif.h'
-    
+#endif    
       INTEGER :: ij,ll
       REAL, dimension(ij,ll) :: Field
       INTEGER :: ierr
       
-      call Gather_Field(Field,ij,ll,0)
-!$OMP CRITICAL (MPI)
+      IF (using_mpi) THEN
+        call Gather_Field(Field,ij,ll,0)
+!$OMP CRITICAL (MPI)
+#ifdef CPP_MPI
       call MPI_BCAST(Field,ij*ll,MPI_REAL8,0,COMM_LMDZ,ierr)
-!$OMP END CRITICAL (MPI)
+#endif
+!$OMP END CRITICAL (MPI)
+      ENDIF
       
     end subroutine AllGather_Field
@@ -442,6 +509,7 @@
 #include "dimensions.h"
 #include "paramet.h"    
+#ifdef CPP_MPI
     include 'mpif.h'
-    
+#endif    
       INTEGER :: ij,ll
       REAL, dimension(ij,ll) :: Field
@@ -449,8 +517,13 @@
       INTEGER :: ierr
       
-!$OMP CRITICAL (MPI)
+      IF (using_mpi) THEN
+      
+!$OMP CRITICAL (MPI)
+#ifdef CPP_MPI
       call MPI_BCAST(Field,ij*ll,MPI_REAL8,rank,COMM_LMDZ,ierr)
-!$OMP END CRITICAL (MPI)
-      
+#endif
+!$OMP END CRITICAL (MPI)
+      
+      ENDIF
     end subroutine Broadcast_Field
         
Index: /LMDZ4/trunk/libf/dyn3dpar/startvar.F
===================================================================
--- /LMDZ4/trunk/libf/dyn3dpar/startvar.F	(revision 999)
+++ /LMDZ4/trunk/libf/dyn3dpar/startvar.F	(revision 1000)
@@ -521,5 +521,8 @@
             CASE ('snow')
                   champ(:) = 0.0
-            CASE ('deltat')
+cIM "slab" ocean
+            CASE ('tslab')
+                   champ(:) = 0.0
+            CASE ('seaice')
                   champ(:) = 0.0
             CASE ('rugmer')
@@ -1051,5 +1054,5 @@
       REAL, ALLOCATABLE :: var_tmp2d(:,:), var_tmp3d(:,:,:)
       REAL, ALLOCATABLE :: ax(:), ay(:), yder(:)
-       REAL, ALLOCATABLE :: varrr(:,:,:)
+!       REAL, ALLOCATABLE :: varrr(:,:,:)
       INTEGER, ALLOCATABLE :: lind(:)
     !
@@ -1059,5 +1062,5 @@
           ALLOCATE(var_ana3d(iml_dyn, jml_dyn, llm_dyn))
       ENDIF
-          ALLOCATE(varrr(iml_dyn, jml_dyn, llm_dyn))
+!          ALLOCATE(varrr(iml_dyn, jml_dyn, llm_dyn))
     !
     !
@@ -1170,5 +1173,8 @@
 
       DEALLOCATE(lon_rad)
+      DEALLOCATE(lon_ini)
       DEALLOCATE(lat_rad)
+      DEALLOCATE(lat_ini)
+      DEALLOCATE(lev_dyn)
       DEALLOCATE(var_tmp2d)
       DEALLOCATE(var_tmp3d)
Index: /LMDZ4/trunk/libf/dyn3dpar/times.F90
===================================================================
--- /LMDZ4/trunk/libf/dyn3dpar/times.F90	(revision 999)
+++ /LMDZ4/trunk/libf/dyn3dpar/times.F90	(revision 1000)
@@ -138,24 +138,33 @@
     use parallel
     implicit none
+#ifdef CPP_MPI    
     include 'mpif.h'
+#endif
     integer :: ierr
     integer :: data_size
     real, allocatable,dimension(:,:) :: tmp_table
-    
-    if (AllTimer_IsActive) then
-    
-    allocate(tmp_table(max_size,nb_timer))
-    
-    data_size=max_size*nb_timer
-    
-    tmp_table(:,:)=timer_table(:,:,mpi_rank)
-    call mpi_allgather(tmp_table(1,1),data_size,MPI_REAL8,timer_table(1,1,mpi_rank),data_size,MPI_REAL8,COMM_LMDZ,ierr)
-
-    tmp_table(:,:)=timer_table_sqr(:,:,mpi_rank)
-    call mpi_allgather(tmp_table(1,1),data_size,MPI_REAL8,timer_table_sqr(1,1,mpi_rank),data_size,MPI_REAL8,COMM_LMDZ,ierr)
-    
-    deallocate(tmp_table)
-    
-    endif
+
+    IF (using_mpi) THEN    
+   
+      if (AllTimer_IsActive) then
+    
+    
+      allocate(tmp_table(max_size,nb_timer))
+    
+      data_size=max_size*nb_timer
+    
+      tmp_table(:,:)=timer_table(:,:,mpi_rank)
+#ifdef CPP_MPI 
+      call mpi_allgather(tmp_table(1,1),data_size,MPI_REAL_LMDZ,timer_table(1,1,0),data_size,MPI_REAL_LMDZ,COMM_LMDZ,ierr)
+#endif
+      tmp_table(:,:)=timer_table_sqr(:,:,mpi_rank)
+#ifdef CPP_MPI
+      call mpi_allgather(tmp_table(1,1),data_size,MPI_REAL_LMDZ,timer_table_sqr(1,1,0),data_size,MPI_REAL_LMDZ,COMM_LMDZ,ierr)
+#endif    
+      deallocate(tmp_table)
+    
+      endif
+      
+    ENDIF ! using_mpi
     
   end subroutine allgather_timer
@@ -164,5 +173,7 @@
     use parallel
     implicit none
+#ifdef CPP_MPI
     include 'mpif.h'
+#endif
     integer :: ierr
     integer :: data_size
@@ -170,24 +181,31 @@
     integer, allocatable,dimension(:,:),target :: tmp_iter
     integer :: istats
-    
-    if (AllTimer_IsActive) then
-    
-    allocate(tmp_table(max_size,nb_timer))
-    allocate(tmp_iter(max_size,nb_timer))
+
+    IF (using_mpi) THEN
+        
+      if (AllTimer_IsActive) then
+    
+      allocate(tmp_table(max_size,nb_timer))
+      allocate(tmp_iter(max_size,nb_timer))
    
-    data_size=max_size*nb_timer
-
-    tmp_table(:,:)=timer_average(:,:,mpi_rank)
-    call mpi_allgather(tmp_table(1,1),data_size,MPI_REAL8,timer_average(1,1,0),data_size,MPI_REAL8,COMM_LMDZ,ierr)
-
-    tmp_table(:,:)=timer_delta(:,:,mpi_rank)
-    call mpi_allgather(tmp_table(1,1),data_size,MPI_REAL8,timer_delta(1,1,0),data_size,MPI_REAL8,COMM_LMDZ,ierr)
-
-    tmp_iter(:,:)=timer_iteration(:,:,mpi_rank)
-    call mpi_allgather(tmp_iter(1,1),data_size,MPI_INTEGER,timer_iteration(1,1,0),data_size,MPI_INTEGER,COMM_LMDZ,ierr)
-    
-    deallocate(tmp_table)
-    
-    endif
+      data_size=max_size*nb_timer
+
+      tmp_table(:,:)=timer_average(:,:,mpi_rank)
+#ifdef CPP_MPI
+      call mpi_allgather(tmp_table(1,1),data_size,MPI_REAL_LMDZ,timer_average(1,1,0),data_size,MPI_REAL_LMDZ,COMM_LMDZ,ierr)
+#endif
+      tmp_table(:,:)=timer_delta(:,:,mpi_rank)
+#ifdef CPP_MPI
+      call mpi_allgather(tmp_table(1,1),data_size,MPI_REAL_LMDZ,timer_delta(1,1,0),data_size,MPI_REAL_LMDZ,COMM_LMDZ,ierr)
+#endif
+      tmp_iter(:,:)=timer_iteration(:,:,mpi_rank)
+#ifdef CPP_MPI
+      call mpi_allgather(tmp_iter(1,1),data_size,MPI_INTEGER,timer_iteration(1,1,0),data_size,MPI_INTEGER,COMM_LMDZ,ierr)
+#endif    
+      deallocate(tmp_table)
+    
+      endif
+      
+    ENDIF  ! using_mpî
   end subroutine allgather_timer_average
   
Index: /LMDZ4/trunk/libf/dyn3dpar/top_bound_p.F
===================================================================
--- /LMDZ4/trunk/libf/dyn3dpar/top_bound_p.F	(revision 1000)
+++ /LMDZ4/trunk/libf/dyn3dpar/top_bound_p.F	(revision 1000)
@@ -0,0 +1,113 @@
+      SUBROUTINE top_bound_p( vcov,ucov,teta, du,dv,dh )
+      USE parallel
+      IMPLICIT NONE
+c
+#include "dimensions.h"
+#include "paramet.h"
+#include "comconst.h"
+CC#include "comgeom2.h"
+
+
+c ..  DISSIPATION LINEAIRE A HAUT NIVEAU, RUN MESO,
+C     F. LOTT DEC. 2006
+c                                 (  10/12/06  )
+
+c=======================================================================
+c
+c   Auteur:  F. LOTT  
+c   -------
+c
+c   Objet:
+c   ------
+c
+c   Dissipation linéaire (ex top_bound de la physique)
+c
+c=======================================================================
+c-----------------------------------------------------------------------
+c   Declarations:
+c   -------------
+
+#include "comgeom.h"
+#include "comdissipn.h"
+
+c   Arguments:
+c   ----------
+
+      REAL ucov(iip1,jjp1,llm),vcov(iip1,jjm,llm),teta(iip1,jjp1,llm)
+      REAL dv(iip1,jjm,llm),du(iip1,jjp1,llm),dh(iip1,jjp1,llm)
+
+c   Local:
+c   ------
+
+      REAL uzon(jjp1,llm),vzon(jjm,llm),tzon(jjp1,llm)
+      
+      INTEGER NDAMP
+      PARAMETER (NDAMP=4)
+      integer i	
+      REAL :: rdamp(llm) = 
+     &   (/(0., i =1,llm-NDAMP),0.125E-5,.25E-5,.5E-5,1.E-5/) 
+
+      INTEGER j,l,jjb,jje
+
+
+C  CALCUL DES CHAMPS EN MOYENNE ZONALE:
+
+      jjb=jj_begin
+      jje=jj_end
+      IF (pole_sud) jje=jj_end-1
+
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)      
+      do l=1,llm
+        do j=jjb,jje
+          vzon(j,l)=0.
+          do i=1,iim
+            vzon(j,l)=vzon(j,l)+vcov(i,j,l)/float(iim)
+          enddo
+        enddo
+      enddo
+c$OMP END DO NOWAIT   
+
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)      
+      do l=1,llm
+        do j=jjb,jje
+          do i=1,iip1
+            dv(i,j,l)=dv(i,j,l)-rdamp(l)*(vcov(i,j,l)-vzon(j,l))
+          enddo
+        enddo
+      enddo
+c$OMP END DO NOWAIT
+
+      jjb=jj_begin
+      jje=jj_end
+      IF (pole_nord) jjb=jj_begin+1
+      IF (pole_sud)  jje=jj_end-1
+
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)      
+      do l=1,llm
+        do j=jjb,jje
+          uzon(j,l)=0.
+          tzon(j,l)=0.
+          do i=1,iim
+            uzon(j,l)=uzon(j,l)+ucov(i,j,l)/float(iim)
+            tzon(j,l)=tzon(j,l)+teta(i,j,l)/float(iim)
+          enddo
+        enddo
+      enddo
+c$OMP END DO NOWAIT
+
+C   AMORTISSEMENTS LINEAIRES:
+
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)      
+      do l=1,llm
+        do j=jjb,jje
+          do i=1,iip1
+            du(i,j,l)=du(i,j,l)-rdamp(l)*(ucov(i,j,l)-uzon(j,l))
+            dh(i,j,l)=dh(i,j,l)-rdamp(l)*(teta(i,j,l)-tzon(j,l))
+          enddo
+       enddo
+      enddo
+c$OMP END DO NOWAIT
+      
+
+      RETURN
+      END
